import { BaseController } from '@/api/BaseController';
import { RequestOption } from '@/common/http/types';
import { ANY_OBJECT } from '@/types/generic';
import { TableData } from '@/common/types/table';
import { useUrlBuilder } from '@/common/hooks/useUrl';
import TourismTravelNotesContentWrite from '@/types/table/tourismTravelNotesContentWrite';
import { API_CONTEXT } from '../config';

const { buildGetUrl } = useUrlBuilder();

export interface TourismTravelNotesContentWriteData extends TourismTravelNotesContentWrite {
  __cascade_add_temp_id__?: string | number | undefined;
}

export default class TourismTravelNotesContentWriteController extends BaseController {
  static list(params: ANY_OBJECT, httpOptions?: RequestOption) {
    return super.post<TableData<TourismTravelNotesContentWriteData>>(API_CONTEXT + '/app/tourismTravelNotesContentWrite/list', params, httpOptions);
  }
  static view(params: ANY_OBJECT, httpOptions?: RequestOption) {
    return super.get<TourismTravelNotesContentWriteData>(API_CONTEXT + '/app/tourismTravelNotesContentWrite/view', params, httpOptions);
  }
  static export(params: ANY_OBJECT, fileName: string) {
    return super.download(API_CONTEXT + '/app/tourismTravelNotesContentWrite/export', params, fileName);
  }
  static import(params: ANY_OBJECT) {
    return super.upload(API_CONTEXT + '/app/tourismTravelNotesContentWrite/import', params);
  }
  static printUrl(params: ANY_OBJECT) {
    return buildGetUrl(API_CONTEXT + '/app/tourismTravelNotesContentWrite/print', params);
  }
  static add(params: ANY_OBJECT, httpOptions?: RequestOption) {
    return super.post(API_CONTEXT + '/app/tourismTravelNotesContentWrite/add', params, httpOptions);
  }
  static update(params: ANY_OBJECT, httpOptions?: RequestOption) {
    return super.post(API_CONTEXT + '/app/tourismTravelNotesContentWrite/update', params, httpOptions);
  }
  static delete(params: ANY_OBJECT, httpOptions?: RequestOption) {
    return super.post(API_CONTEXT + '/app/tourismTravelNotesContentWrite/delete', params, httpOptions);
  }
  static deleteBatch(params: ANY_OBJECT, httpOptions?: RequestOption) {
    return super.post(API_CONTEXT + '/app/tourismTravelNotesContentWrite/deleteBatch', params, httpOptions);
  }
}
